//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Red
#property indicator_color2  LimeGreen
#property indicator_color3  Aqua
#property indicator_color4  Magenta

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    EnvelopePeriod  = 15;
extern int    EnvelopeMaShift = 0;
extern int    EnvelopeMaMode  = MODE_EMA;
extern int    UpperPrice      = 0;
extern int    LowerPrice      = 0;
extern double Deviation       = 0.25;
extern int    arrowthickness  = 2;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = true;
extern bool   alertsEmail     = true;
extern string soundFile       = "alert2.wav"; 

//
//
//
//
//

double UpEnv[];
double DnEnv[];
double CrossUp[];
double CrossDn[];
double trend[];
string short_name;
int    timeFrame;

//
//
//
//                    
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,UpEnv);    SetIndexShift(0,EnvelopeMaShift);
   SetIndexBuffer(1,DnEnv);    SetIndexShift(1,EnvelopeMaShift);
   SetIndexBuffer(2,CrossUp);  SetIndexStyle(2, DRAW_ARROW,0,arrowthickness); SetIndexArrow(2, 233);
   SetIndexBuffer(3,CrossDn);  SetIndexStyle(3, DRAW_ARROW,0,arrowthickness); SetIndexArrow(3, 234);
   SetIndexBuffer(4,trend);
   
   timeFrame = stringToTimeFrame(TimeFrame);
   SetIndexShift(0,EnvelopeMaShift * timeFrame/Period());  
   SetIndexShift(1,EnvelopeMaShift * timeFrame/Period());  
   
   IndicatorShortName(timeFrameToString(timeFrame)+" envelopes("+EnvelopePeriod+")");
   
   
return(0);
}  
  
//+------------------------------------------------------------------
//|                             
//+------------------------------------------------------------------
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMax(Bars-counted_bars,3*timeFrame/Period());
         
   //
   //
   //
   //
   //
   
   for (i = limit; i >= 0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      UpEnv[i]  = (1+Deviation/100)*iMA(NULL,timeFrame,EnvelopePeriod,EnvelopeMaShift,EnvelopeMaMode,UpperPrice,y);
      DnEnv[i]  = (1-Deviation/100)*iMA(NULL,timeFrame,EnvelopePeriod,EnvelopeMaShift,EnvelopeMaMode,LowerPrice,y);
      
      trend[i] = trend[i+1];
         if (Close[i]<DnEnv[i]) trend[i] = 1;
         if (Close[i]>UpEnv[i]) trend[i] =-1;
         
         //
         //
         //
         //
         //
         
         CrossUp[i] = EMPTY_VALUE;
         CrossDn[i] = EMPTY_VALUE;
         if (trend[i] !=trend[i+1])
         if (trend[i] == 1)
               CrossUp[i] = Low[i] - iATR(NULL,0,20,i)/2.0;
         else  CrossDn[i] = High[i]+ iATR(NULL,0,20,i)/2.0;
   }

   //
   //
   //
   //
   //
         
         if (alertsOn)
         {
           if (alertsOnCurrent)
                int whichBar = 0;
           else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
           if (trend[whichBar] != trend[whichBar+1])
           if (trend[whichBar] == 1)
                 doAlert("uptrend");
           else  doAlert("downtrend");       
   }
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Envelopes ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Envelopes " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Envelopes "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}


 
   

